diff --git a/lib/igt_kms.c b/lib/igt_kms.c
index 1e0585f..ded614f 100644
--- a/lib/igt_kms.c
+++ b/lib/igt_kms.c
@@ -2092,6 +2092,13 @@ void igt_output_override_mode(igt_output_t *output, drmModeModeInfo *mode)
 	output->use_override_mode = true;
 }
 
+/**
+ * igt_output_set_pipe:
+ * @output: Output which the pipe will be attached to
+ * @pipe: Pipe to attach to the output
+ *
+ * Attach a pipe to an output.
+ */
 void igt_output_set_pipe(igt_output_t *output, enum pipe pipe)
 {
 	igt_display_t *display = output->display;
@@ -2114,6 +2121,13 @@ igt_plane_t *igt_output_get_plane(igt_output_t *output, enum igt_plane plane)
 	return igt_pipe_get_plane(pipe, plane);
 }
 
+/**
+ * igt_plane_set_fb:
+ * @plane: Plane which the framebuffer with be attached to
+ * @fb: Framebuffer to attach to the plane
+ *
+ * Attach a framebufer to a plane.
+ */
 void igt_plane_set_fb(igt_plane_t *plane, struct igt_fb *fb)
 {
 	igt_pipe_t *pipe = plane->pipe;
@@ -2143,6 +2157,14 @@ void igt_plane_set_fb(igt_plane_t *plane, struct igt_fb *fb)
 	plane->size_changed = true;
 }
 
+/**
+ * igt_plane_set_position:
+ * @plane: A plane
+ * @x: New X position of the plane
+ * @y: New Y position of the plane
+ *
+ * Set position of a plane.
+ */
 void igt_plane_set_position(igt_plane_t *plane, int x, int y)
 {
 	igt_pipe_t *pipe = plane->pipe;
@@ -2232,6 +2254,15 @@ void igt_fb_set_size(struct igt_fb *fb, igt_plane_t *plane,
 	plane->fb_changed = true;
 }
 
+/**
+ * igt_pipe_set_rotation:
+ * @plane: A plane on which to set the panning
+ * @x: x
+ * @y: y
+ *
+ * Sets the panning of a plane. The new panning will be committed at
+ * plane commit time via drmModeSetCrtc().
+ */
 void igt_plane_set_panning(igt_plane_t *plane, int x, int y)
 {
 	igt_pipe_t *pipe = plane->pipe;
@@ -2263,6 +2294,13 @@ static const char *rotation_name(igt_rotation_t rotation)
 	}
 }
 
+/**
+ * igt_pipe_set_rotation:
+ * @plane: A plane on which to set the rotation
+ * @rotation:
+ *
+ * Sets the rotation of a plane.
+ */
 void igt_plane_set_rotation(igt_plane_t *plane, igt_rotation_t rotation)
 {
 	igt_pipe_t *pipe = plane->pipe;
@@ -2294,6 +2332,17 @@ igt_pipe_replace_blob(igt_pipe_t *pipe, uint64_t *blob, void *ptr, size_t length
 	*blob = blob_id;
 }
 
+/**
+ * igt_pipe_set_degamma_lut:
+ * @pipe: A pipe on which to set a gamma LUT
+ * @ptr: A pointer to an array of #drm_color_lut elements
+ * @size: The length of the array in bytes or 0
+ *
+ * Sets a degamma LUT onto the pipe. A new DRM blob is created to hold
+ * the degamma LUT and the data pointed by ptr is copied into it. The
+ * previous DRM blob set on the pipe is destroyed. Call this function
+ * with size = 0 to disable the degamma LUT on @pipe.
+ */
 void
 igt_pipe_set_degamma_lut(igt_pipe_t *pipe, void *ptr, size_t length)
 {
@@ -2301,6 +2350,18 @@ igt_pipe_set_degamma_lut(igt_pipe_t *pipe, void *ptr, size_t length)
 	pipe->color_mgmt_changed = 1;
 }
 
+/**
+ * igt_pipe_set_ctm_matrix:
+ * @pipe: A pipe on which to set a transformation matrix
+ * @ptr: A pointer to a #drm_color_ctm structure
+ * @size: The size of the #drm_color_ctm structure or 0
+ *
+ * Sets a transformation matrix onto the pipe. A new DRM blob is
+ * created to hold the matrix and the data pointed by ptr is copied
+ * into it. The previous DRM blob set on the pipe is destroyed. Call
+ * this function with size = 0 to disable the transformation matrix on
+ * @pipe.
+ */
 void
 igt_pipe_set_ctm_matrix(igt_pipe_t *pipe, void *ptr, size_t length)
 {
@@ -2308,6 +2369,17 @@ igt_pipe_set_ctm_matrix(igt_pipe_t *pipe, void *ptr, size_t length)
 	pipe->color_mgmt_changed = 1;
 }
 
+/**
+ * igt_pipe_set_gamma_lut:
+ * @pipe: A pipe on which to set a gamma LUT
+ * @ptr: A pointer to an array of #drm_color_lut elements
+ * @size: The length of the array in bytes or 0
+ *
+ * Sets a gamma LUT onto the pipe. A new DRM blob is created to hold
+ * the gamma LUT and the data pointed by ptr is copied into it. The
+ * previous DRM blob set on the pipe is destroyed. Call this function
+ * with size = 0 to disable the gamma LUT on @pipe.
+ */
 void
 igt_pipe_set_gamma_lut(igt_pipe_t *pipe, void *ptr, size_t length)
 {